-------------------------------------------------------------------------
--
-- Code by Genrall of Ravencrest-US Disillusioned guild
-- http://disillusioned.x10host.com
--
-- forwards.lua - TabardMaster's forward defines file for functions.
--
-- Forward define local variables that will become functions in later 
--	code.  IE:
-- 		local functionname
-- 		[code]
-- 		functionname = function() end

-- LUA has only 8 data types:  nil, boolean, number, string, function, 
--	userdata, thread, and table, and global or local scopes.

-- Local functions need defining in scope before calling the value that
-- 	the function stores.  Data types can be changed by redefining, but
--	redefining as a second local will create a second local.

-- Code version 124 
-- (c) 2011-2017 Disillusioned.  All rights reserved.
--
-------------------------------------------------------------------------




-- Glue functions; generic code
local array_join
local tohex
local unhex
-- END of glue functions


-- Helper functions
local setRGBAcolor
local colorPickerCallback
local showColorPicker
-- END of helper functions


-- Profiles & player options
local defaultProfile
local backupProfile
local getGlobalOption
local setGlobalOption
local getPlayerCategory
local getPlayerOption
local getPlayerSetting
local setPlayerCategory
local setPlayerOption
local setPlayerSetting
-- End profile & options functions


-- Chat panel functions
local vprint
local dprint
-- End chat panel functions


-- Standalone functions that call the API
local getItemLink
local TabardOMatic
local getFreeBag
local getCurrentTabard
local NEWgetAllTabards
local gat
local getAllGearsets
-- END of standalone API call functions


-- Options panels & support
local iofOpenPanel
local iofRefresh
local createButton
local createCheckButton
local createSlider
local createTextField
local createFilledPane
local setPaneTitle
local createGroupWidget
local makeModeOption
-- End option panel & support code


-- Reputation functions
local resetReputationBlock
local getFactionNameFromFactionId
local getTabardFromFactionId
local getFactionIdFromTabard
local getAllegianceFactionId
local setWatchedFactionById
local getAllReputationsByID
local startReputationTimer
local updateReputationBar
--- End Reputation functions


-- Checks & validations
local checkIfGearset
local checkRangedOption
local checkToggleOption
local validateTabard
local validateAllTabards
local validateAllGearsets
-- end Checks & validations


-- Tabard functions
local NEWwearTabard
local isInTabardGroup
local pickRandomTabard
local pickClosestTabard
local pickFurthestTabard
local pickBestTabard
-- End tabard functions
-- Tabards and tabard accessories - old code
local getBestTabard
local getRandomTabard
local vTabard
--local pickTabard
-- end Tabards and tabard accessories


-- Gear
local NEWwearGear
-- end Gear
	

--- Mapping functions
local resetZoneChangeBlock
local isInMapType
local isInEnemyCity
local isInFriendlyCity
local isInPvPZone
local isInHome
local getMapType
--local NEWzoneDecoder
local zoneChangedEventHandler
local exitCombatEventHandler
local startZonechangeTimer
-- end Mapping functions


-- Option panel displays
local setDisplay
local setUsageState
-- end option panel displays


-- Menus.
local submenuTabards
local submenuEquipment
local quickMenu
local tabardMenu
local gearMenu
-- end Menus


-- Options Panels; creation
local createMainPanel
local createInstancePanel
local createGearMasterPanel
local createAdvancedPanel
local createAboutPanel
-- End Options Panels


--  info panel functions
local createInfoFrame
local showInfoFrameHelp
local setInfoFrameColors
-- local updateInfoFrame 			-- global function
--  END info panel functions


-- LDB code
--	local tm_LDB_OnClick			-- global function
--	local tm_LDB_tooltipShow		-- global function
-- End LDB code



-- Event driven
local startMeUp
-- end Event driven


local tm_EventHandler
local tm_SlashHandler

--[[ this is used during development only
local function dump(o)
-- display contents of variable, similiar to /dump console command.  Needs work.
	if type(o) == 'table' then
		local s = '{\n'
		for k, v in pairs(o) do
         if type(k) ~= 'number' then k = '"' .. k .. '"'; end
         s = s .. '["' .. k .. '"] = "' .. dump(v) .. '",\n'
      end
      return s .. '}\n'
   else
      return tostring(o)
   end

--try this instead:
		if   ... table={'Hello','number', 1}
		then ... dump('table name', table)

function dump(name, table, indent)
  if name then print(name); end
  indent = indent or 0
  local keys = {}
  for k in pairs(table) do
    keys[#keys + 1] = k
    table.sort(keys, function(a, b)
      local ta, tb = type(a), type(b)
      if (ta ~= tb) then
        return ta < tb
      else
        return a < b
      end
    end)
  end

  print(string.rep('  ', indent)..'{')
  indent = indent + 1
  for k, v in pairs(table) do
    local key = k
    if (type(key) == 'string') then
      if not (string.match(key, '^[A-Za-z_][0-9A-Za-z_]*$')) then
        key = "['"..key.."']";
      end
    elseif (type(key) == 'number') then
      key = "["..key.."]";
    end

    if (type(v) == 'table') then
      if (next(v)) then
        printf("%s%s =", string.rep('  ', indent), tostring(key))
        dump(nil, v, indent)
      else
        printf("%s%s = {},", string.rep('  ', indent), tostring(key))
      end 
    elseif (type(v) == 'string') then
      printf("%s%s = %s,", string.rep('  ', indent), tostring(key), "'"..v.."'")
    else
      printf("%s%s = %s,", string.rep('  ', indent), tostring(key), tostring(v))
    end
  end
  indent = indent - 1
  print(string.rep('  ', indent)..'}')
end
]]

function dump(t) 
    local print_r_cache={}
    local function sub_print_r(t,indent)
        if (print_r_cache[tostring(t)]) then
            print(indent.."*"..tostring(t))
        else
            print_r_cache[tostring(t)]=true
            if (type(t)=="table") then
                for pos,val in pairs(t) do
                    if (type(val)=="table") then
                        print(indent.."["..pos.."] => "..tostring(t).." {")
                        sub_print_r(val,indent..string.rep(" ",string.len(pos)+8))
                        print(indent..string.rep(" ",string.len(pos)+6).."}")
                    else
                        print(indent.."["..pos.."] => "..tostring(val))
                    end
                end
            else
                print(indent..tostring(t))
            end
        end
    end
    sub_print_r(t,"  ")
end
